Index: uspace/lib/drv/include/ops/nic.h
===================================================================
--- uspace/lib/drv/include/ops/nic.h	(revision 77ad86ca9ec1edac5e39ab6e237ea58c13b85efb)
+++ uspace/lib/drv/include/ops/nic.h	(revision 46577995860f76c247274a43eb6f67b944f0d3a8)
@@ -44,68 +44,68 @@
 typedef struct nic_iface {
 	/** Mandatory methods */
-	int (*send_frame)(ddf_fun_t *, void *, size_t);
-	int (*callback_create)(ddf_fun_t *);
-	int (*get_state)(ddf_fun_t *, nic_device_state_t *);
-	int (*set_state)(ddf_fun_t *, nic_device_state_t);
-	int (*get_address)(ddf_fun_t *, nic_address_t *);
+	errno_t (*send_frame)(ddf_fun_t *, void *, size_t);
+	errno_t (*callback_create)(ddf_fun_t *);
+	errno_t (*get_state)(ddf_fun_t *, nic_device_state_t *);
+	errno_t (*set_state)(ddf_fun_t *, nic_device_state_t);
+	errno_t (*get_address)(ddf_fun_t *, nic_address_t *);
 	
 	/** Optional methods */
-	int (*set_address)(ddf_fun_t *, const nic_address_t *);
-	int (*get_stats)(ddf_fun_t *, nic_device_stats_t *);
-	int (*get_device_info)(ddf_fun_t *, nic_device_info_t *);
-	int (*get_cable_state)(ddf_fun_t *, nic_cable_state_t *);
+	errno_t (*set_address)(ddf_fun_t *, const nic_address_t *);
+	errno_t (*get_stats)(ddf_fun_t *, nic_device_stats_t *);
+	errno_t (*get_device_info)(ddf_fun_t *, nic_device_info_t *);
+	errno_t (*get_cable_state)(ddf_fun_t *, nic_cable_state_t *);
 	
-	int (*get_operation_mode)(ddf_fun_t *, int *, nic_channel_mode_t *,
+	errno_t (*get_operation_mode)(ddf_fun_t *, int *, nic_channel_mode_t *,
 	    nic_role_t *);
-	int (*set_operation_mode)(ddf_fun_t *, int, nic_channel_mode_t,
+	errno_t (*set_operation_mode)(ddf_fun_t *, int, nic_channel_mode_t,
 	    nic_role_t);
-	int (*autoneg_enable)(ddf_fun_t *, uint32_t);
-	int (*autoneg_disable)(ddf_fun_t *);
-	int (*autoneg_probe)(ddf_fun_t *, uint32_t *, uint32_t *,
+	errno_t (*autoneg_enable)(ddf_fun_t *, uint32_t);
+	errno_t (*autoneg_disable)(ddf_fun_t *);
+	errno_t (*autoneg_probe)(ddf_fun_t *, uint32_t *, uint32_t *,
 	    nic_result_t *, nic_result_t *);
-	int (*autoneg_restart)(ddf_fun_t *);
-	int (*get_pause)(ddf_fun_t *, nic_result_t *, nic_result_t *,
+	errno_t (*autoneg_restart)(ddf_fun_t *);
+	errno_t (*get_pause)(ddf_fun_t *, nic_result_t *, nic_result_t *,
 		uint16_t *);
-	int (*set_pause)(ddf_fun_t *, int, int, uint16_t);
+	errno_t (*set_pause)(ddf_fun_t *, int, int, uint16_t);
 	
-	int (*unicast_get_mode)(ddf_fun_t *, nic_unicast_mode_t *, size_t,
+	errno_t (*unicast_get_mode)(ddf_fun_t *, nic_unicast_mode_t *, size_t,
 	    nic_address_t *, size_t *);
-	int (*unicast_set_mode)(ddf_fun_t *, nic_unicast_mode_t,
+	errno_t (*unicast_set_mode)(ddf_fun_t *, nic_unicast_mode_t,
 	    const nic_address_t *, size_t);
-	int (*multicast_get_mode)(ddf_fun_t *, nic_multicast_mode_t *, size_t,
+	errno_t (*multicast_get_mode)(ddf_fun_t *, nic_multicast_mode_t *, size_t,
 	    nic_address_t *, size_t *);
-	int (*multicast_set_mode)(ddf_fun_t *, nic_multicast_mode_t,
+	errno_t (*multicast_set_mode)(ddf_fun_t *, nic_multicast_mode_t,
 	    const nic_address_t *, size_t);
-	int (*broadcast_get_mode)(ddf_fun_t *, nic_broadcast_mode_t *);
-	int (*broadcast_set_mode)(ddf_fun_t *, nic_broadcast_mode_t);
-	int (*defective_get_mode)(ddf_fun_t *, uint32_t *);
-	int (*defective_set_mode)(ddf_fun_t *, uint32_t);
-	int (*blocked_sources_get)(ddf_fun_t *, size_t, nic_address_t *,
+	errno_t (*broadcast_get_mode)(ddf_fun_t *, nic_broadcast_mode_t *);
+	errno_t (*broadcast_set_mode)(ddf_fun_t *, nic_broadcast_mode_t);
+	errno_t (*defective_get_mode)(ddf_fun_t *, uint32_t *);
+	errno_t (*defective_set_mode)(ddf_fun_t *, uint32_t);
+	errno_t (*blocked_sources_get)(ddf_fun_t *, size_t, nic_address_t *,
 	    size_t *);
-	int (*blocked_sources_set)(ddf_fun_t *, const nic_address_t *, size_t);
+	errno_t (*blocked_sources_set)(ddf_fun_t *, const nic_address_t *, size_t);
 	
-	int (*vlan_get_mask)(ddf_fun_t *, nic_vlan_mask_t *);
-	int (*vlan_set_mask)(ddf_fun_t *, const nic_vlan_mask_t *);
-	int (*vlan_set_tag)(ddf_fun_t *, uint16_t, bool, bool);
+	errno_t (*vlan_get_mask)(ddf_fun_t *, nic_vlan_mask_t *);
+	errno_t (*vlan_set_mask)(ddf_fun_t *, const nic_vlan_mask_t *);
+	errno_t (*vlan_set_tag)(ddf_fun_t *, uint16_t, bool, bool);
 	
-	int (*wol_virtue_add)(ddf_fun_t *, nic_wv_type_t, const void *,
+	errno_t (*wol_virtue_add)(ddf_fun_t *, nic_wv_type_t, const void *,
 	    size_t, nic_wv_id_t *);
-	int (*wol_virtue_remove)(ddf_fun_t *, nic_wv_id_t);
-	int (*wol_virtue_probe)(ddf_fun_t *, nic_wv_id_t, nic_wv_type_t *,
+	errno_t (*wol_virtue_remove)(ddf_fun_t *, nic_wv_id_t);
+	errno_t (*wol_virtue_probe)(ddf_fun_t *, nic_wv_id_t, nic_wv_type_t *,
 	    size_t, void *, size_t *);
-	int (*wol_virtue_list)(ddf_fun_t *, nic_wv_type_t, size_t,
+	errno_t (*wol_virtue_list)(ddf_fun_t *, nic_wv_type_t, size_t,
 	    nic_wv_id_t *, size_t *);
-	int (*wol_virtue_get_caps)(ddf_fun_t *, nic_wv_type_t, int *);
-	int (*wol_load_info)(ddf_fun_t *, nic_wv_type_t *, size_t,
+	errno_t (*wol_virtue_get_caps)(ddf_fun_t *, nic_wv_type_t, int *);
+	errno_t (*wol_load_info)(ddf_fun_t *, nic_wv_type_t *, size_t,
 	    uint8_t *, size_t *);
 	
-	int (*offload_probe)(ddf_fun_t *, uint32_t *, uint32_t *);
-	int (*offload_set)(ddf_fun_t *, uint32_t, uint32_t);
+	errno_t (*offload_probe)(ddf_fun_t *, uint32_t *, uint32_t *);
+	errno_t (*offload_set)(ddf_fun_t *, uint32_t, uint32_t);
 	
-	int (*poll_get_mode)(ddf_fun_t *, nic_poll_mode_t *,
+	errno_t (*poll_get_mode)(ddf_fun_t *, nic_poll_mode_t *,
 	    struct timeval *);
-	int (*poll_set_mode)(ddf_fun_t *, nic_poll_mode_t,
+	errno_t (*poll_set_mode)(ddf_fun_t *, nic_poll_mode_t,
 	    const struct timeval *);
-	int (*poll_now)(ddf_fun_t *);
+	errno_t (*poll_now)(ddf_fun_t *);
 } nic_iface_t;
 